package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_condition_statistics.git/db/model"
	zhios_condition_statistics_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_condition_statistics.git/utils"
	"time"
	"xorm.io/xorm"
)

//统计数量
func GetCouponUserTotalByLeaveSum(Db *xorm.Engine, condition *model.CommCouponUserTotal, cols string) (float64, error) {
	total, err := Db.Sum(condition, cols)
	if err != nil {
		return 0, err
	}
	return total, err
}
func GetCouponUserByUid(Db *xorm.Engine, uid string) (*[]model.CommCouponUserTotal, error) {
	var m []model.CommCouponUserTotal
	if err := Db.Where("uid = " + uid + " and leave_coupon_amount_value>=0  ").Asc("leave_coupon_amount_value").Find(&m); err != nil {
		return nil, err
	}
	return &m, nil
}
func GetCouponUserTotalByLeaveSumWithType(Db *xorm.Engine, uid int, pvdType, cols string) (float64, error) {
	var m model.CommCouponUserTotal
	total, err := Db.Where("uid = "+zhios_condition_statistics_utils.IntToStr(uid)+" and (pvd_type LIKE '%"+pvdType+"%' or pvd_type='ordinary' )").Sum(m, cols)
	if err != nil {
		return 0, err
	}
	return total, err
}

func GetCouponUserTotalByLeaveSumWithTypes(Db *xorm.Engine, uid int, pvdType, cols string) (float64, error) {
	var m model.CommCouponUserTotal
	str := ""
	if pvdType != "" {
		str = "  and (pvd_type = '\"+pvdType+\"' )"
	}
	total, err := Db.Where("uid = "+zhios_condition_statistics_utils.IntToStr(uid)+str).Sum(m, cols)
	if err != nil {
		return 0, err
	}
	return total, err
}

func GetCouponUserTotalByLeaveSumWithTypeSession(session *xorm.Session, uid int, pvdType string) (*[]model.CommCouponUserTotal, error) {
	var m []model.CommCouponUserTotal
	if err := session.Where("uid = " + zhios_condition_statistics_utils.IntToStr(uid) + " and leave_coupon_amount_value>=0  and (pvd_type LIKE '%" + pvdType + "%' or pvd_type='ordinary' )").Asc("leave_coupon_amount_value").Find(&m); err != nil {
		return nil, err
	}
	return &m, nil
}
func GetCouponUserTotalByNegative(Db *xorm.Engine, uid int, pvdType, cols string) (float64, error) {
	var m model.CommCouponUserTotal
	total, err := Db.Where("uid = "+zhios_condition_statistics_utils.IntToStr(uid)+" and leave_coupon_amount_value<0  and (pvd_type LIKE '%"+pvdType+"%' or pvd_type='ordinary' )").Sum(m, cols)
	if err != nil {
		return 0, err
	}
	return total, err
}

//查询对应记录
func GetCouponUserTotalByOne(session *xorm.Session, uid int, pvdType string) (*model.CommCouponUserTotal, error) {
	var m model.CommCouponUserTotal
	if has, err := session.Where("uid = ? and pvd_type=? ", uid, pvdType).Asc("leave_coupon_amount_value").Get(&m); err != nil || !has {
		return nil, err
	}
	return &m, nil
}
func GetCouponUserTotalById(eg *xorm.Engine, uid int, id string) (*model.CommCouponUserTotal, error) {
	var m model.CommCouponUserTotal
	if has, err := eg.Where("uid = ? and id=? ", uid, id).Asc("leave_coupon_amount_value").Get(&m); err != nil || !has {
		return nil, err
	}
	return &m, nil
}
func GetCouponUserTotalByType(eg *xorm.Engine, uid, pvdType string) (*model.CommCouponUserTotal, error) {
	var m model.CommCouponUserTotal
	has, err := eg.Where("uid = ? and pvd_type=? ", uid, pvdType).Asc("leave_coupon_amount_value").Get(&m)
	if err != nil {
		return nil, err
	}
	if has == false {
		m = model.CommCouponUserTotal{
			Uid:                    zhios_condition_statistics_utils.StrToInt(uid),
			UsePvd:                 "",
			CouponAmountValue:      "",
			CreateAt:               time.Now(),
			UpdateAt:               time.Now(),
			LeaveCouponAmountValue: "",
			PvdType:                pvdType,
		}
		has1, err := eg.InsertOne(&m)
		if err != nil || has1 == 0 {
			return nil, err
		}
	}
	return &m, nil
}

//查询对应记录
func GetCouponUserTotalByOneEg(eg *xorm.Engine, uid int, pvdType string) (*model.CommCouponUserTotal, error) {
	var m model.CommCouponUserTotal
	if has, err := eg.Where("uid = ? and pvd_type=? ", uid, pvdType).Asc("leave_coupon_amount_value").Get(&m); err != nil || !has {
		return nil, err
	}
	return &m, nil
}
func GetCouponUserTotalByOneSession(session *xorm.Session, uid int, pvdType string) (*model.CommCouponUserTotal, error) {
	var m model.CommCouponUserTotal
	if has, err := session.Where("uid = ? and pvd_type=? ", uid, pvdType).Asc("leave_coupon_amount_value").Get(&m); err != nil || !has {
		return nil, err
	}
	return &m, nil
}

//写入或保存
func CouponUserTotalByInsertWithUpdate(session *xorm.Session, m *model.CommCouponUserTotal) (has int64, err error) {
	if m.Id > 0 {
		has, err = session.ID(m.Id).Cols("coupon_amount_value,leave_coupon_amount_value,user_pvd").Update(m)
	} else {
		has, err = session.InsertOne(m)
	}
	return has, err
}

//写入或保存
func CouponUserTotalByInsertWithUpdateEg(eg *xorm.Engine, m *model.CommCouponUserTotal) (has int64, err error) {
	if m.Id > 0 {
		has, err = eg.ID(m.Id).Cols("coupon_amount_value,leave_coupon_amount_value").Update(m)
	} else {
		has, err = eg.InsertOne(m)
	}
	return has, err
}
