package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_condition_statistics.git/db/model"
	zhios_condition_statistics_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_condition_statistics.git/utils"
	zhios_condition_statistics_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_condition_statistics.git/utils/logx"
	"fmt"
	"strings"
	"xorm.io/xorm"
)

func O2oOrdByTime(Db *xorm.Engine, uid, buyType, state, stime, etime interface{}, isSettle int) (float64, error) {
	sess := Db.Where("uid = ? ", uid)
	serializeStr := zhios_condition_statistics_utils.SerializeStr(state)
	if isSettle == 1 {
		sess = sess.And(" settle_time > ? AND settle_time < ?", stime, etime)
	} else if strings.Contains(serializeStr, "1") {
		sess = sess.And(" create_time > ? AND create_time < ?", stime, etime).In("state", state)
	} else {
		sess = sess.And(" confirm_time > ? AND confirm_time < ?", stime, etime).In("state", state)
	}
	total, err := sess.Sum(&model.O2oOrd{}, "cost_price")
	fmt.Println(err)
	fmt.Println(total)
	if err != nil {
		return 0, zhios_condition_statistics_logx.Error(err)
	}
	return total, nil
}
func O2oOrdPayToMerchantByTime(Db *xorm.Engine, uid, buyType, state, stime, etime interface{}, isSettle int) (float64, error) {
	sess := Db.Where("uid = ?  AND state in (?)", uid, state)
	if isSettle == 1 {
		sess = sess.And(" settle_time > ? AND settle_time < ?", stime, etime)
	} else {
		sess = sess.And(" create_time > ? AND create_time < ?", stime, etime)
	}
	total, err := sess.Sum(&model.O2oPayToMerchant{}, "actual_pay_amount")
	fmt.Println(err)
	fmt.Println(total)
	if err != nil {
		return 0, zhios_condition_statistics_logx.Error(err)
	}
	return total, nil
}

func O2oOrd(Db *xorm.Engine, uid, buyType, state interface{}, isSettle int) (float64, error) {
	sess := Db.Where("uid = ?", uid)
	if isSettle == 1 {
		sess.And("settle_time is not null")
	} else {
		sess.In("state", state)
	}
	total, err := sess.Sum(&model.O2oOrd{}, "cost_price")
	fmt.Println(err)
	fmt.Println(total)
	if err != nil {
		return 0, zhios_condition_statistics_logx.Error(err)
	}
	return total, nil
}
func O2oOrdPayToMerchant(Db *xorm.Engine, uid, buyType, state interface{}, isSettle int) (float64, error) {
	sess := Db.Where("uid = ?  ", uid)
	if isSettle == 1 {
		sess.And("settle_time is not null")
	} else {
		sess.And("state in (?)", state)
	}
	total, err := sess.Sum(&model.O2oPayToMerchant{}, "actual_pay_amount")
	fmt.Println(err)
	fmt.Println(total)
	if err != nil {
		return 0, zhios_condition_statistics_logx.Error(err)
	}
	return total, nil
}
