package model

import (
	"time"
)

type CommCouponUserOrd struct {
	Id                 int       `json:"id" xorm:"not null pk autoincr comment('主键id') INT(11)"`
	Uid                int       `json:"uid" xorm:"not null comment('用户id') INT(11)"`
	IsRevoke           int       `json:"is_revoke" xorm:"not null comment('') INT(11)"`
	PayMethod          int       `json:"pay_method" xorm:"default 0 comment('支付方式：1balance 2alipay 3wx_pay（类型为1时，此值必填）') TINYINT(1)"`
	OrdType            int       `json:"ord_type" xorm:"not null default 0 comment('订单类型（1购买，2领取）') TINYINT(1)"`
	UsePvd             string    `json:"use_pvd" xorm:"comment('可使用渠道（json（[]string））') VARCHAR(255)"`
	PackageId          int       `json:"package_id" xorm:"default 0 comment('套餐id（类型为2时，此值必填）') INT(11)"`
	CouponAmountValue  string    `json:"coupon_amount_value" xorm:"not null default 0.0000 comment('优惠劵额度') DECIMAL(12,4)"`
	RevokeValue        string    `json:"revoke_value" xorm:"not null default 0.0000 comment('') DECIMAL(12,4)"`
	PayAmountValue     string    `json:"pay_amount_value" xorm:"comment('付款金额（类型为1时，此值必填）') DECIMAL(12,4)"`
	Discount           string    `json:"discount" xorm:"comment('折扣（类型为1时，此值必填）') DECIMAL(6,4)"`
	PayAmount          string    `json:"pay_amount" xorm:"comment('实际付款金额（类型为1时，此值必填）') DECIMAL(12,4)"`
	CreateAt           time.Time `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') TIMESTAMP"`
	UpdateAt           time.Time `json:"update_at" xorm:"default 'CURRENT_TIMESTAMP' comment('更新时间') TIMESTAMP"`
	PvdType            string    `json:"pvd_type" xorm:"default '' comment('渠道类型 ordinary:通用 GUIDE:导购 SELF_MALL:自营 O2O:小店 GUIDE_SELF_MALL:导购+自营 SELF_MALL_O2O:自营+小店 ') VARCHAR(255)"`
	GoodsType          string    `json:"goods_type" xorm:"default '' comment('商品渠道') VARCHAR(255)"`
	Type               int       `json:"type" xorm:"default '0' comment('收入0 支出1 ') VARCHAR(255)"`
	Batch              int       `json:"batch" xorm:"default '0' comment('批次(用于购买商品记录） ') VARCHAR(255)"`
	ExpectedRefundTime int       `json:"expected_refund_time" xorm:"default '0' comment('预计退回时间 如果购买过不会退回 ') VARCHAR(255)"`
	RefundState        int       `json:"refund_state" xorm:"default '0' comment('批次(用于购买商品记录） ') VARCHAR(255)"`
	Gid                string    `json:"gid" xorm:"default '' comment('商品id') VARCHAR(255)"`
	GoodsTitle         string    `json:"goods_title" xorm:"default '' comment('商品标题') VARCHAR(255)"`
	Oid                string    `json:"oid" xorm:"default '' comment('') VARCHAR(255)"`
	TransformInfo      string    `json:"transform_info"  xorm:"TEXT""`
	ToUid              int       `json:"to_uid" xorm:"default 0 comment('') INT(11)"`
	BeforeAmout        string    `json:"before_amout" xorm:"not null comment('变更前数量') DECIMAL(16,6)"`
	AfterAmout         string    `json:"after_amout" xorm:"not null comment('变更后数量') DECIMAL(16,6)"`
}
