package model

import (
	"time"
)

type UserLevelUpgradeTask struct {
	Id                  int       `json:"id" xorm:"not null pk autoincr comment('主键id') INT(11)"`
	Pid                 int       `json:"pid" xorm:"default 0 comment('父级任务id') INT(11)"`
	SchemeId            int       `json:"scheme_id" xorm:"not null default 0 comment('区域代理方案id') INT(11)"`
	IsMustTask          int       `json:"is_must_task" xorm:"not null default 0 comment('是否必做(0,1)') TINYINT(1)"`
	TaskTypePvd         int       `json:"task_type_pvd" xorm:"not null default 0 comment('task_type=15时生效，表示店铺渠道 0 o2o+b2c 1 o2o 3b2c') INT(10)"`
	OrdState            int       `json:"ord_state" xorm:"not null default 0 comment('task_type=15时生效，表示店铺渠道 0 o2o+b2c 1 o2o 3b2c') INT(10)"`
	TaskTypeCount       int       `json:"task_type_count" xorm:"not null default 0 comment('task_type=15时生效，表示店铺的数量') INT(10)"`
	TaskTypeSecondCount int       `json:"task_type_second_count" xorm:"not null default 0 comment('task_type=17时生效，表示每条链的数量') INT(10)"`
	TaskType            int       `json:"task_type" xorm:"not null default 0 comment('1:累计自购订单总数,2:累计到账佣金,3:累计直推粉丝数量,4:累计团队有效直推人数,5:累计团队符合相应等级的人数,6:付费任务') TINYINT(2)"`
	TaskTypeLevelId     int       `json:"task_type_level_id" xorm:"not null default 0 comment('task_type=5时生效，表示等级id') INT(10)"`
	WithinDays          int       `json:"within_days" xorm:"default 0 comment('多少天内完成') INT(11)"`
	FinishCount         string    `json:"finish_count" xorm:"not null default '' comment('多少天内完成的指标数') VARCHAR(11)"`
	FinishTaskNum       int       `json:"finish_task_num" xorm:"comment('完成任务数量（如果是组合条件，则该数指的是完成几组）') INT(11)"`
	IsUnifyAgentPrice   int       `json:"is_unify_agent_price" xorm:"comment('是否统一代理价格（1统一价格，2按区域设置不用价格）') TINYINT(1)"`
	PayLevels           string    `json:"pay_levels" xorm:"not null default '' comment('表示开启1月2季3年4永久 amount 价格 ，cost_price 原价') VARCHAR(255)"`
	CreateAt            time.Time `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') TIMESTAMP"`
	UpdateAt            time.Time `json:"update_at" xorm:"default 'CURRENT_TIMESTAMP' comment('更新时间') TIMESTAMP"`
}
